/****************************************************************************
 * This file is part of the project AqHome.
 * AqHome (c) by 2023 Martin Preuss, all rights reserved.
 *
 * The license for this file can be found in the file COPYING which you
 * should have received along with this file.
 ****************************************************************************/

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif


#include "aqhome/msg/msg_node.h"

#include <gwenhywfar/debug.h>


#define COM_USE_CRC8 1



#ifdef COM_USE_CRC8
static uint8_t _calcCrc8Checksum(const uint8_t *ptr, uint8_t len);
#else
static uint8_t _calcXorChecksum(const uint8_t *ptr, uint8_t len);
#endif


uint8_t AQH_NodeMsg_GetDestAddress(const GWEN_MSG *msg)
{
  if (msg && GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_OFFS_ALL_DATA_BEGIN) {
    const uint8_t *ptr;

    ptr=GWEN_Msg_GetConstBuffer(msg);
    return ptr[AQH_MSG_OFFS_ALL_DEST_ADDRESS];
  }

  return 0;
}



uint8_t AQH_NodeMsg_GetMsgType(const GWEN_MSG *msg)
{
  if (msg && GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_OFFS_ALL_DATA_BEGIN) {
    const uint8_t *ptr;

    ptr=GWEN_Msg_GetConstBuffer(msg);
    return ptr[AQH_MSG_OFFS_ALL_MSG_TYPE];
  }

  return 0;
}



uint8_t AQH_NodeMsg_GetSourceAddress(const GWEN_MSG *msg)
{
  if (msg && GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_OFFS_ALL_DATA_BEGIN) {
    const uint8_t *ptr;

    ptr=GWEN_Msg_GetConstBuffer(msg);
    return ptr[AQH_MSG_OFFS_ALL_SRC_ADDRESS];
  }

  return 0;
}



uint8_t AQH_NodeMsg_GetMsgPayloadLen(const GWEN_MSG *msg)
{
  if (msg && GWEN_Msg_GetBytesInBuffer(msg)>=AQH_MSG_OFFS_ALL_DATA_BEGIN) {
    const uint8_t *ptr;

    ptr=GWEN_Msg_GetConstBuffer(msg);
    return ptr[AQH_MSG_OFFS_ALL_PAYLOAD_LEN];
  }

  return 0;
}



int AQH_NodeMsg_IsMsgComplete(const GWEN_MSG *msg)
{
  if (msg) {
    uint8_t msgLen;

    msgLen=GWEN_Msg_GetBytesInBuffer(msg);
    if (msgLen>=AQH_MSG_OFFS_ALL_DATA_BEGIN) {
      const uint8_t *ptr;
      uint8_t len;

      ptr=GWEN_Msg_GetConstBuffer(msg);
      len=ptr[AQH_MSG_OFFS_ALL_PAYLOAD_LEN]+AQH_MSG_OFFS_ALL_PAYLOAD_BEGIN+1;
      if (len>AQH_MAXMSGSIZE)
        return -1;
      else if (msgLen>=len)
        return 1;
    }
  }

  return 0;
}



int AQH_NodeMsg_IsChecksumValid(const GWEN_MSG *msg)
{
  if (msg && AQH_NodeMsg_IsMsgComplete(msg)) {
#ifdef COM_USE_CRC8
    return (_calcCrc8Checksum(GWEN_Msg_GetConstBuffer(msg), GWEN_Msg_GetBytesInBuffer(msg))==0)?1:0;
#else
    return (_calcXorChecksum(GWEN_Msg_GetConstBuffer(msg), GWEN_Msg_GetBytesInBuffer(msg))==0)?1:0;
#endif
  }
  return 0;
}



int AQH_NodeMsg_AddChecksum(GWEN_MSG *msg)
{
  if (msg) {
    int rv;

#ifdef COM_USE_CRC8
    rv=GWEN_Msg_AddByte(msg, _calcCrc8Checksum(GWEN_Msg_GetConstBuffer(msg), GWEN_Msg_GetBytesInBuffer(msg)));
#else
    rv=GWEN_Msg_AddByte(msg, _calcXorChecksum(GWEN_Msg_GetConstBuffer(msg), GWEN_Msg_GetBytesInBuffer(msg)));
#endif
    if (rv<0) {
      DBG_INFO(NULL, "here (%d)", rv);
      return rv;
    }
    return 0;
  }
  return GWEN_ERROR_GENERIC;
}



uint32_t AQH_NodeMsg_GetUint32At(const GWEN_MSG *msg, int offs, int defaultValue)
{
  if ((GWEN_Msg_GetBytesInBuffer(msg)>=offs+4)) {
    const uint8_t *ptr;

    ptr=GWEN_Msg_GetConstBuffer(msg)+offs;
    return (uint32_t)(ptr[0])+(ptr[1]<<8)+(ptr[2]<<16)+(ptr[3]<<24);
  }
  return defaultValue;
}



uint16_t AQH_NodeMsg_GetUint16At(const GWEN_MSG *msg, int offs, int defaultValue)
{
  if ((GWEN_Msg_GetBytesInBuffer(msg)>=offs+2)) {
    const uint8_t *ptr;

    ptr=GWEN_Msg_GetConstBuffer(msg)+offs;
    return (uint16_t)(ptr[0])+(ptr[1]<<8);
  }
  return defaultValue;
}



uint8_t AQH_NodeMsg_GetUint8At(const GWEN_MSG *msg, int offs, int defaultValue)
{
  if ((GWEN_Msg_GetBytesInBuffer(msg)>=offs+1)) {
    const uint8_t *ptr;

    ptr=GWEN_Msg_GetConstBuffer(msg)+offs;
    return ptr[0];
  }
  return defaultValue;
}



void AQH_NodeMsg_DumpToBuffer(const GWEN_MSG *msg, GWEN_BUFFER *dbuf, const char *sText)
{
  GWEN_Buffer_AppendArgs(dbuf,
                         "0x%02x->0x%02x: %d %s\n",
                         AQH_NodeMsg_GetSourceAddress(msg),
                         AQH_NodeMsg_GetDestAddress(msg),
                         AQH_NodeMsg_GetMsgType(msg),
                         sText);
}




uint32_t AQH_NodeMsg_GetMsgGroup(uint8_t msgType)
{
  switch(msgType) {
  case AQH_MSG_TYPE_PING:
  case AQH_MSG_TYPE_PONG:
  case AQH_MSG_TYPE_COMSENDSTATS:
  case AQH_MSG_TYPE_COMRECVSTATS:
  case AQH_MSG_TYPE_TWIBUSMEMBER:
  case AQH_MSG_TYPE_DEBUG:
  case AQH_MSG_TYPE_DEVICE:
    return AQH_MSG_TYPEGROUP_INFO;
  case AQH_MSG_TYPE_VALUE:
  case AQH_MSG_TYPE_VALUE2:
    return AQH_MSG_TYPEGROUP_VALUES;
  case AQH_MSG_TYPE_NEED_ADDRESS:
  case AQH_MSG_TYPE_HAVE_ADDRESS:
  case AQH_MSG_TYPE_CLAIM_ADDRESS:
  case AQH_MSG_TYPE_DENY_ADDRESS:
  case AQH_MSG_TYPE_ADDRESS_RANGE:
    return AQH_MSG_TYPEGROUP_ADDRESS;
  case AQH_MSG_TYPE_NET_SET_ACCEPTED_MSGGROUPS:
    return AQH_MSG_TYPEGROUP_ADMIN;
  default:
    return 0;
  }
}




#ifdef COM_USE_CRC8
uint8_t _calcCrc8Checksum(const uint8_t *ptr, uint8_t len)
{
  int i;
  uint8_t x=0xff;

  for (i=0; i<len; i++, ptr++) {
    int j;

    x^=*ptr;
    for (j=0; j<8; j++) {
      if (x & 0x80)
	x=(uint8_t) (x<<1)^0x97;
      else
	x<<=1;
    }
  }

  return x;
}
#else
uint8_t _calcXorChecksum(const uint8_t *ptr, uint8_t len)
{
  int i;
  uint8_t x=0;

  for (i=0; i<len; i++, ptr++) {
    x^=*ptr;
  }

  return x;
}
#endif






